varying vec3 lightVec;
varying vec3 eyeVec;
varying vec2 texCoord;
uniform sampler2D colorMap;
uniform sampler2D normalMap;
uniform float invRadius;
uniform float mode;

void main (void)
{
	float distSqr = dot(lightVec, lightVec);
	float att = clamp(1.0 - invRadius * sqrt(distSqr), 0.0, 1.0);
	vec3 lVec = lightVec * inversesqrt(distSqr);

	vec3 vVec = normalize(eyeVec);
	
	vec4 base = texture2D(colorMap, texCoord);
	
	vec3 bump = normalize( texture2D(normalMap, texCoord).xyz * 2.0 - 1.0);

	vec4 vAmbient = gl_LightSource[0].ambient * gl_FrontMaterial.ambient;

	float diffuse = max( dot(lVec, bump), 0.0 );
	
	//vec4 vDiffuse = gl_LightSource[0].diffuse * gl_FrontMaterial.diffuse * diffuse;	
	vec4 vDiffuse = vec4(diffuse, diffuse, diffuse, 1);	

	float specular = pow(clamp(dot(reflect(-lVec, bump), vVec), 0.0, 1.0), gl_FrontMaterial.shininess );
	
	vec4 vSpecular = gl_LightSource[0].specular * gl_FrontMaterial.specular * specular;

	if (mode >= 0.0 && mode < 0.5) {
		gl_FragColor = (vAmbient*base + vDiffuse*base + vSpecular) * att;
		//gl_FragColor = vDiffuse * base * att;
	} else if (mode >= 0.5 && mode < 1.5) {
		gl_FragColor = vDiffuse * att;
	}

	//gl_FragColor = vAmbient*base + vDiffuse*base + vSpecular;
	//gl_FragColor = vec4(normalize(lightVec) * 0.5 + 0.5, 1);
	//gl_FragColor = vec4(diffuse, diffuse, diffuse, 1);
	//gl_FragColor = vSpecular;
	//gl_FragColor = vAmbient;
	//gl_FragColor = vec4(normalize(lVec) * 0.5 + 0.5, 1);
	//gl_FragColor = vec4(gl_LightSource[0].position.xyz, 1);
	//gl_FragColor = vec4(normalize(tmpVec) * 0.5 + 0.5, 1);
	//gl_FragColor = vec4(normalize(tangent) * 0.5 + 0.5, 1);
	//gl_FragColor = vec4(normalize(binormal) * 0.5 + 0.5, 1);
	//gl_FragColor = vec4(normalize(normal) * 0.5 + 0.5, 1);
}
