varying vec3 lightVec; 
varying vec3 eyeVec;
varying vec2 texCoord;

void main(void) {

	gl_Position = ftransform();

	texCoord = gl_MultiTexCoord0.xy;
	
	// compute tangent and binormal components
	//
	// http://www.ozone3d.net/tutorials/mesh_deformer_p2.php#tangent_space
	//
	vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
	vec3 tangent;
	vec3 binormal;
	
	vec3 c1 = cross(normal, vec3(0.0, 0.0, 1.0));
	vec3 c2 = cross(normal, vec3(0.0, 1.0, 0.0));
	
	if(length(c1) > length(c2)) {
		tangent = c1;
	} else {
		tangent = c2;
	}
	tangent = normalize(tangent);
	
	binormal = cross(normal, tangent); 
	binormal = normalize(binormal);
	
	vec3 vVertex = vec3(gl_ModelViewMatrix * gl_Vertex);
	vec3 tmpVec = gl_LightSource[0].position.xyz - vVertex;

	lightVec.x = dot(tmpVec, tangent);
	lightVec.y = dot(tmpVec, binormal);
	lightVec.z = dot(tmpVec, normal);

	tmpVec = -vVertex;
	eyeVec.x = dot(tmpVec, tangent);
	eyeVec.y = dot(tmpVec, binormal);
	eyeVec.z = dot(tmpVec, normal);
}