#ifndef COLOR_H
#define COLOR_H

#include "Ptr.h"
#include "PtrInterface.h"

namespace GameEngine {

	using namespace Fwk;

	class Color4 : public PtrInterface<Color4> {
	public:
		Color4(float rr, float gg, float bb, float aa) :
			r(rr),
			g(gg),
			b(bb),
			a(aa) {
		}
		Color4(float rr, float gg, float bb) :
			r(rr),
			g(gg),
			b(bb),
			a(1) {
		}
		Color4() : r(0), g(0), b(0), a(1) { }

		float r, g, b, a;

		static Ptr<Color4> Red() { return new Color4(1, 0, 0); }
		static Ptr<Color4> Green() { return new Color4(0, 1, 0); }
		static Ptr<Color4> Blue() { return new Color4(0, 0, 1); }
		static Ptr<Color4> Black() { return new Color4(0, 0, 0); }
		static Ptr<Color4> White() { return new Color4(1, 1, 1); }
		static Ptr<Color4> Yellow() { return new Color4(1, 1, 0); }
	};
}

#endif