#ifndef CUSTOMSCENENODES_H
#define CUSTOMSCENENODES_H

#include <string>

#include "SceneNode.h"
#include "Drawable.h"
#include "Terrain.h"
#include "Model.h"
#include "Ptr.h"
#include "PtrInterface.h"

namespace GameEngine {

	using namespace Fwk;
	using namespace std;

/*
	class OctreeSceneNode : public SceneNode {
	public:
		OctreeSceneNode() : SceneNode() { }
		OctreeSceneNode(string name) : SceneNode(name) { }

		void render() { }
	protected:
		// TODO: octree data structure here
	};
*/	

	class DrawableSceneNode : public SceneNode {
	public:
		DrawableSceneNode() : SceneNode() { }
		DrawableSceneNode(string name) : SceneNode(name) { }
		DrawableSceneNode(Ptr<Drawable> drawableObject) : SceneNode(), drawableObject_(drawableObject) { }

		void render();

	protected:
		Ptr<Drawable> drawableObject_;
	};

	class ModelSceneNode : public DrawableSceneNode {
	public:
		ModelSceneNode() : DrawableSceneNode() { }
		ModelSceneNode(Ptr<Model> model) : DrawableSceneNode(model) { }

		//void render();
	protected:
		void applyTransform();
	};

	class TerrainSceneNode : public SceneNode {
	public:
		TerrainSceneNode() : SceneNode("Terrain_SN") { }
		TerrainSceneNode(Ptr<Terrain> terrain);

		void render();
	protected:
		Ptr<Terrain> terrain_;
	};

	class CubeSceneNode : public SceneNode {
	public:
		CubeSceneNode() : SceneNode() { }
		CubeSceneNode(string name) : SceneNode(name) { }

		void render();
	};

	class SphereSceneNode : public SceneNode {
	public:
		SphereSceneNode() : SceneNode() { }
		SphereSceneNode(string name) : SceneNode(name) { }

		void render();
	};

	class LightSceneNode : public SceneNode {
	public:
		LightSceneNode() : SceneNode() { }
		LightSceneNode(string name) : SceneNode(name) { }

		void render();
	};
}

#endif