#ifndef MODELLOADER_H
#define MODELLOADER_H

#include "Model.h"
#include "Geometry.h"
#include "Ptr.h"
#include "PtrInterface.h"

namespace GameEngine {

	using namespace Fwk;
	using namespace std;

	class ModelLoader : public PtrInterface<ModelLoader> {
	public:
		ModelLoader() { }

		Ptr<Model> load3DSFile(string filename);

	protected:
		// convert from M3DS to GameEngine format
		Ptr<Vertex3> vertexFrom3ds(M3DS::Vertex v3ds);
		Ptr<Mapping> mappingFrom3ds(M3DS::Mapping m3ds);
		Ptr<Face> faceFrom3ds(M3DS::Face f3ds);
		Ptr<Mesh> meshFrom3ds(M3DS::Mesh m3ds, string name);
		Ptr<RGBColor> rgbFrom3ds(M3DS::RGB c3ds);
		Ptr<Material> materialFrom3ds(Ptr<M3DS::Material> m3ds);

		// compute the normal for a face
		Ptr<Vec3> normal(Ptr<SubMesh> submesh, Ptr<Face> face);

		vector<unsigned int> textureIds;
	};
}

#endif