#ifndef SHADER_H
#define SHADER_H

#include <string>

#include "Ptr.h"
#include "PtrInterface.h"

namespace GameEngine {

	using namespace Fwk;
	using namespace std;

	class Shader : public PtrInterface<Shader> {
	public:
		Shader(string vertShaderFile, string fragShaderFile) :
		  vertShaderFile_(vertShaderFile),
		  fragShaderFile_(fragShaderFile),
		  vertShader_(0),
		  fragShader_(0),
		  program_(0),
		  mode_(0) {
			initShader();
		}

		GLuint program() { return program_; }

		void bind();
		void unbind();
		void modeInc() { mode_++; }
		int mode() { return mode_; }

	protected:
		string vertShaderFile_;
		string fragShaderFile_;
		GLuint vertShader_;
		GLuint fragShader_;
		GLuint program_;
		int mode_;

		void initShader();
		string readFile(string filename);
		void checkShaderLog(GLuint shaderId);
	};
}

#endif