#include <SDL/SDL.h>
#include <SDL/SDL_opengl.h>
#include <SDL/SDL_image.h>
#include <iostream>
#include <sstream>

#include "ShaderManager.h"

namespace GameEngine {

	using namespace std;

	const string ShaderManager::DEFAULT_SHADER_DIR = "shaders/";
	const string ShaderManager::BUMPMAP_SHADER = "bumpmap";
	const string ShaderManager::BUMPMAP_VERT_SHADER = "bumpmap.vert";
	const string ShaderManager::BUMPMAP_FRAG_SHADER = "bumpmap.frag";
	//const string ShaderManager::BUMPMAP_VERT_SHADER = "shader1.vert";
	//const string ShaderManager::BUMPMAP_FRAG_SHADER = "shader1.frag";

	Ptr<ShaderManager> ShaderManager::instance_ = NULL;

	Ptr<ShaderManager> ShaderManager::Instance() {
		if (instance_ == NULL) {
			instance_ = new ShaderManager;
		}
		return instance_;
	}

	void ShaderManager::loadShaders(string dir) {
		string vertpath, fragpath;

		vertpath = DEFAULT_SHADER_DIR + BUMPMAP_VERT_SHADER;
		fragpath = DEFAULT_SHADER_DIR + BUMPMAP_FRAG_SHADER;
		shaders_[BUMPMAP_SHADER] = new Shader(vertpath, fragpath);
	}
}
