#ifndef SHADERMANAGER_H
#define SHADERMANAGER_H

#include <string>
#include <map>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>

#include "Ptr.h"
#include "PtrInterface.h"
#include "UniqueEntity.h"
#include "Shader.h"

namespace GameEngine {

	using namespace Fwk;
	using namespace std;

	class ShaderManager : public UniqueEntity {
	public:
		static const string BUMPMAP_SHADER;

		static Ptr<ShaderManager> Instance();

		Ptr<Shader> shader(string name) { return shaders_[name]; }

	protected:
		static const string DEFAULT_SHADER_DIR;
		static const string BUMPMAP_VERT_SHADER;
		static const string BUMPMAP_FRAG_SHADER;

		ShaderManager() :
		  UniqueEntity(),
		  shaders_() {
			loadShaders(DEFAULT_SHADER_DIR);
		}

		static Ptr<ShaderManager> instance_;
		map<string, Ptr<Shader> > shaders_;

		void loadShaders(string dir);
	};
}

#endif
