#ifndef TEXTURE_H
#define TEXTURE_H

#include <string>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>

#include "Ptr.h"
#include "PtrInterface.h"
#include "UniqueEntity.h"
#include "Printable.h"
#include "Copiable.h"

namespace GameEngine {

	using namespace Fwk;
	using namespace std;

	class Texture : public UniqueEntity, public Printable {
	public:
		Texture() :
		  UniqueEntity(),
		  filename_(""),
		  texId_(0) { }

		Texture(string filename) :
		  UniqueEntity(filename),
		  filename_(filename),
		  texId_(0) {
			loadTexture(filename);
		}

		unsigned int loadTexture(string filename);

		void bind();
		void unbind();

		virtual string toString();

		string filename() { return filename_; }
		unsigned int texId() { return texId_; }

		bool operator == (Ptr<Texture> tex) {
			return (filename_ == tex->filename());
		}

	protected:
		string filename_;
		unsigned int texId_;

		SDL_Surface *loadImage(string filename);
		unsigned int storeGlTexture(SDL_Surface *surface);
	};
}

#endif
