#include <SDL/SDL.h>
#include <SDL/SDL_opengl.h>
#include <SDL/SDL_image.h>
#include <iostream>
#include <sstream>

#include "TextureManager.h"

namespace GameEngine {

	using namespace std;

	const string TextureManager::DEFAULT_TEX_DIR = "textures/";
	const string TextureManager::CAL_IMAGE_FILE = "cal.gif";
	const string TextureManager::UCLA_IMAGE_FILE = "ucla.gif";
	const string TextureManager::USC_IMAGE_FILE = "usc.gif";
	const string TextureManager::GRASS_IMAGE_FILE = "grass.png";
	const string TextureManager::GRASS_BUMPMAP_IMAGE_FILE = "grass_bumpmap.png";
	const string TextureManager::HARDGLOW_IMAGE_FILE = "hardglow.bmp";
	const string TextureManager::DIRT_BUMPMAP_IMAGE_FILE = "dirt_bumpmap.jpg";
	const string TextureManager::DIRT_IMAGE_FILE = "dirt.jpg";
	const string TextureManager::GLOW_IMAGE_FILE = "glow.bmp";

	Ptr<TextureManager> TextureManager::instance_ = NULL;

	Ptr<TextureManager> TextureManager::Instance() {
		if (instance_ == NULL) {
			instance_ = new TextureManager;
		}
		return instance_;
	}

	void TextureManager::loadTextures(string dir) {
		string path;

		path = DEFAULT_TEX_DIR + CAL_IMAGE_FILE;
		textures_[CAL_IMAGE_FILE] = new Texture(path);

		path = DEFAULT_TEX_DIR + UCLA_IMAGE_FILE;
		textures_[UCLA_IMAGE_FILE] = new Texture(path);

		path = DEFAULT_TEX_DIR + USC_IMAGE_FILE;
		textures_[USC_IMAGE_FILE] = new Texture(path);

		path = DEFAULT_TEX_DIR + GRASS_IMAGE_FILE;
		textures_[GRASS_IMAGE_FILE] = new Texture(path);

		path = DEFAULT_TEX_DIR + DIRT_IMAGE_FILE;
		textures_[DIRT_IMAGE_FILE] = new Texture(path);

		path = DEFAULT_TEX_DIR + GLOW_IMAGE_FILE;
		textures_[GLOW_IMAGE_FILE] = new Texture(path);

		path = DEFAULT_TEX_DIR + HARDGLOW_IMAGE_FILE;
		textures_[HARDGLOW_IMAGE_FILE] = new Texture(path);

		path = DEFAULT_TEX_DIR + GRASS_BUMPMAP_IMAGE_FILE;
		textures_[GRASS_BUMPMAP_IMAGE_FILE] = new Texture(path);

		path = DEFAULT_TEX_DIR + DIRT_BUMPMAP_IMAGE_FILE;
		textures_[DIRT_BUMPMAP_IMAGE_FILE] = new Texture(path);
	}
}
