#ifndef TEXTUREMANAGER_H
#define TEXTUREMANAGER_H

#include <string>
#include <map>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>

#include "Ptr.h"
#include "PtrInterface.h"
#include "UniqueEntity.h"
#include "Texture.h"

namespace GameEngine {

	using namespace Fwk;
	using namespace std;

	class TextureManager : public UniqueEntity {
	public:
		static const string GRASS_IMAGE_FILE;
		static const string GRASS_BUMPMAP_IMAGE_FILE;
		static const string DIRT_IMAGE_FILE;
		static const string DIRT_BUMPMAP_IMAGE_FILE;
		static const string CAL_IMAGE_FILE;
		static const string UCLA_IMAGE_FILE;
		static const string USC_IMAGE_FILE;
		static const string GLOW_IMAGE_FILE;
		static const string HARDGLOW_IMAGE_FILE;

		static Ptr<TextureManager> Instance();

		Ptr<Texture> texture(string path) { return textures_[path]; }

	protected:
		static const string DEFAULT_TEX_DIR;

		TextureManager() :
		  UniqueEntity(),
		  textures_() {
			loadTextures(DEFAULT_TEX_DIR);
		}

		static Ptr<TextureManager> instance_;
		map<string, Ptr<Texture> > textures_;

		void loadTextures(string dir);
	};
}

#endif
